{$APPTYPE CONSOLE}
{$MAXSTACKSIZE 16000000}

uses SysUtils, Math;

const MaxNN = 100;
      MaxN = MaxNN + 3;
      WayCharacters: set of char = ['|', '-', '+'];
      PossibleCharacters: set of char = ['.', '#', '*', '|', '-', '+'];
      PresentationError: array[boolean] of integer = (3, 2);
      WrongAnswer: array[boolean] of integer = (3, 1);
      OutputFile: array[boolean] of string = ('Answer', 'Output');
      dx: array[1..4] of integer = (-1, 1, 0, 0);
      dy: array[1..4] of integer = (0, 0, -1, 1);

type TMap = array[0..MaxN] of string;
     TRect = record top, left, right, bottom: integer; end;
     TPoint = record x, y: integer; end;

var OutMap, AnsMap: TMap; 
    x, xx, y, yy: integer;
    sx, sy, fx, fy: integer;
    AnsLength, OutLength: integer;
    OutSize, AnsSize, start, finish: TPoint;
    OutDxy, AnsDxy: TPoint;
    prev, curr, next: TPoint;
    rect1, rect2: TRect;
    fin, fout, fans: text;

procedure Ex(const s: string; ec: integer);
begin
  write(s);
  try
    close(fin); close(fout); close(fans);
  except
  end;
  halt(ec);
end;

procedure swap(var a, b: integer);
var t: integer;
begin
  t := a; a := b; b := t;
end;

procedure SwapString(var a, b: string);
var t: string;
begin
  t := a; a := b; b := t;
end;

procedure CheckPair(var a, aa: integer);
begin
  if(a > aa) then swap(a, aa);
end;

function GetRect(var x, y, xx, yy: integer): TRect;
begin
  CheckPair(x, xx); CheckPair(y, yy);
  Result.left := x;  Result.right := xx;
  Result.top := y;  Result.bottom := yy;
end;

function GetTPoint(x, y: integer): TPoint;
begin
  Result.x := x; Result.y := y;
end;

function EqualPoints(var a, b: TPoint): boolean;
begin
  Result := (a.x = b.x) and (a.y = b.y);
end;

procedure ReadMap(var f: text; var map: TMap; IsOut: boolean);
var i, j: integer;
begin
  try
    i := 0;
    while not SeekEof(f) do
      begin
        inc(i);
        if (i > MaxN) then Ex('Too many strings in ' + OutputFile[IsOut], PresentationError[IsOut]);
        readln(f, map[i]);
        if (i > 1) and (length(map[i]) <> length(map[i-1])) then
          Ex('Various strings lengths in ' + OutputFile[IsOut], PresentationError[IsOut]);
        for j := 1 to length(map[i]) do
          if not (map[i, j] in PossibleCharacters) then
            Ex(format('Unknown character %s in (%d; %d) ' + OutputFile[IsOut] + ' position',
              [map[i, j], i,  j]), PresentationError[IsOut]);
      end;
  except on e: Exception do
    Ex(e.Message, PresentationError[IsOut]);
  end;
  if IsOut then OutSize := GetTPoint(length(map[i]), i) else AnsSize := GetTPoint(length(map[i]), i);
end;

procedure NormalizeMap(var map: TMap; var size: TPoint);
var i: integer;
begin
  for i := 1 to size.y shr 1 do
    SwapString(map[i], map[size.y - i + 1]);
end;

procedure CheckPerimeter(var map: TMap; var size: TPoint; var Dxy: TPoint; IsOut: boolean);
var AllBad, AllBad1: boolean;
    i, j: integer;
begin
  AllBad := false; 
  
  AllBad1 := true;
  for j := 1 to size.x do
    if map[1, j] <> '.' then AllBad1 := false;
  AllBad := AllBad or AllBad1;

  AllBad1 := true;
  for j := 1 to size.x do
    if map[size.y, j] <> '.' then AllBad1 := false;
  AllBad := AllBad or AllBad1;

  AllBad1 := true;
  for i := 1 to size.y do
    if map[i, 1] <> '.' then AllBad1 := false;
  AllBad := AllBad or AllBad1;

  AllBad1 := true;
  for i := 1 to size.y do
    if map[i, size.x] <> '.' then AllBad1 := false;
  AllBad := AllBad or AllBad1;
 
  if AllBad then Ex(OutputFile[IsOut] + ' rectangle is not minimal', WrongAnswer[IsOut]);
end;

procedure CheckRect(var map: TMap; var size: TPoint; var rect: TRect; var Dxy: TPoint; var IsOut: boolean);
var i, j: integer;
    AllBad: boolean;
begin
  AllBad := false;
  for i := rect.top to rect.bottom do
    for j := rect.left to rect.right do
      if (i - Dxy.y > size.y) or (j - Dxy.x > size.x) or (map[i - Dxy.y, j - Dxy.x] <> '#') then
        AllBad := true;
  if AllBad then
    Ex('Incorrect rect location in ' + OutputFile[IsOut], WrongAnswer[IsOut]);
end;

procedure FillRect(var map: TMap; var size: TPoint; var rect: TRect; var Dxy: TPoint; var IsOut: boolean);
var i, j: integer;
    AllBad: boolean;
begin
  AllBad := false;
  for i := rect.top to rect.bottom do
    for j := rect.left to rect.right do
      if (i - Dxy.y <= size.y) or (j - Dxy.x <= size.x) then
        map[i - Dxy.y, j - Dxy.x] := '.';
end;


procedure CheckPoint(var map: TMap; var size: TPoint; var point: TPoint; var Dxy: TPoint; var IsOut: boolean);
begin
  if (point.y - Dxy.y <= size.y) and (point.x - Dxy.x <= size.x) and (map[point.y - Dxy.y, point.x - Dxy.x] <> '*') then
    Ex('Incorrect point location in ' + OutputFile[IsOut], WrongAnswer[IsOut]);
end;

procedure FillPoint(var map: TMap; var size: TPoint; var point: TPoint; var Dxy: TPoint; var IsOut: boolean);
begin
  map[point.y - Dxy.y, point.x - Dxy.x] := '.';
end;

procedure CheckMapTruth(var map: TMap; var size: TPoint; var Dxy: TPoint; IsOut: boolean);
var q: TRect;
    i, j: integer;
begin
  CheckPerimeter(map, size, Dxy, IsOut);
  
  if rect1.top < rect2.top then q := rect1 else q := rect2;
  for i := 1 to size.y do
    begin
      for j := 1 to size.x do
        begin
          if map[i, j] = '#' then
            begin
              Dxy.y := q.top - i;
              Dxy.x := q.left - j;
              break;
            end;
        end;
      if map[i, j] = '#' then break;
    end;

  CheckRect(map, size, rect1, Dxy, IsOut);
  CheckRect(map, size, rect2, Dxy, IsOut);

  FillRect(map, size, rect1, Dxy, IsOut);
  FillRect(map, size, rect2, Dxy, IsOut);

  CheckPoint(map, size, start, Dxy, IsOut);
  CheckPoint(map, size, finish, Dxy, IsOut);
  
  FillPoint(map, size, start, Dxy, IsOut);
  FillPoint(map, size, finish, Dxy, IsOut);
end;

function CountWayLength(var map: TMap; var size: TPoint): integer;
var i, j: integer;
begin
  Result := 0;
  for i := 1 to size.y do
    for j := 1 to size.x do
      if map[i, j] in WayCharacters then inc(Result);
end;

function InOutSize(x, y: integer): boolean;
begin
  Result := (x > 0) and (x <= OutSize.x) and (y > 0) and (y <= OutSize.y);
end;

procedure FindNext;
var t: integer;
begin
  for t := 1 to 4 do
    if InOutSize(curr.x+dx[t], curr.y+dy[t]) and (OutMap[curr.y+dy[t], curr.x+dx[t]] in WayCharacters) then
      begin
        next := GetTPoint(curr.x+dx[t], curr.y+dy[t]);
        if not EqualPoints(next, prev) then exit
      end;
end;

procedure FindPrevCurrNextPoints;
var t: integer;
begin
  prev := finish;
  for t := 1 to 4 do
    if InOutSize(finish.x+dx[t], finish.y+dy[t]) and  (OutMap[finish.y+dy[t], finish.x+dx[t]] in WayCharacters) then
      curr := GetTPoint(finish.x+dx[t], finish.y+dy[t]);
  FindNext;
end;

procedure CheckWay;
var AllBad: boolean;
    c: char;
    cnt: integer;
begin
  OutMap[start.y, start.x] := '+';
  FindPrevCurrNextPoints;
  cnt := 0;

  AllBad := false;
  while not EqualPoints(curr, start) do
    begin
      if ((next.x - curr.x = 0) and (curr.x - prev.x <> 0) and
        (next.y - curr.y <> 0) and (curr.y - prev.y = 0)
        or
        (next.x - curr.x <> 0) and (curr.x - prev.x = 0) and
        (next.y - curr.y = 0) and (curr.y - prev.y <> 0))
      and (OutMap[curr.y, curr.x] <> '+') then
        begin
          AllBad := true;
          c := '+';
        end;

      if (next.x - curr.x = 0) and (curr.x - prev.x = 0) and
        (next.y - curr.y <> 0) and (curr.y - prev.y <> 0)
      and (OutMap[curr.y, curr.x] <> '|') then
        begin
          AllBad := true;
          c := '|';
        end;

      if (next.x - curr.x <> 0) and (curr.x - prev.x <> 0) and
        (next.y - curr.y = 0) and (curr.y - prev.y = 0)
      and (OutMap[curr.y, curr.x] <> '-') then
        begin
          AllBad := true;
          c := '-';
        end;

      if AllBad then Ex(format('Wrong way charachter: %s instead of %s in (%d; %d) position',
        [OutMap[curr.y, curr.x], c, OutSize.y - (curr.y - OutDxy.y) + 1, curr.x - OutDxy.x]), 1);

      inc(cnt);
      OutMap[curr.y, curr.x] := '.';
      if cnt > MaxN*MaxN then break;
      prev := curr; curr := next; FindNext;
    end;
  OutMap[start.y, start.x] := '.';
  if cnt > MaxN*MaxN then
    Ex('There''re errors in the way', 2);
  if cnt <> AnsLength then
    Ex(format('Incorrect way length: %d instead of %d',
      [cnt+2, AnsLength+2]), WrongAnswer[cnt >= AnsLength]);
end;

procedure CheckClear;
var i, j: integer;
begin
  for i := 1 to OutSize.y do
    for j := 1 to OutSize.x do
      if OutMap[i, j] <> '.' then
        Ex(format('There''s unnecessary character %s in (%d; %d) position',
          [OutMap[i, j], i, j]), 1);
end;

begin
  try
    assign(fin,paramstr(1)); reset(fin);
  except on e: Exception do
    Ex('Error opening input: ' + e.Message, 3);
  end;
  try
    assign(fans,paramstr(3)); reset(fans);
  except on e: Exception do
    Ex('Error opening answer: ' + e.Message, 3);
  end;
  try
    assign(fout,paramstr(2)); reset(fout);
  except on e: Exception do
    Ex('Can''t open output: ' + e.Message, 2);
  end;

  try
    read(fin, x, y, xx, yy); rect1 := GetRect(x, y, xx, yy);
    read(fin, x, y, xx, yy); rect2 := GetRect(x, y, xx, yy);
    read(fin, sx, sy, fx, fy);
    start := GetTPoint(sx, sy); finish := GetTPoint(fx, fy);

  except on e: Exception do
    Ex('Error reading input: ' + e.Message, 3);
  end;

  ReadMap(fout, OutMap, true);
  ReadMap(fans, AnsMap, false);

  NormalizeMap(OutMap, OutSize);
  NormalizeMap(AnsMap, AnsSize);
  
  CheckMapTruth(OutMap, OutSize, OutDxy, true);
  CheckMapTruth(AnsMap, AnsSize, AnsDxy, false);

  AnsLength := CountWayLength(AnsMap, AnsSize);
  OutLength := CountWayLength(OutMap, OutSize);

  dec(start.x, AnsDxy.x); dec(start.y, AnsDxy.y);
  dec(finish.x, AnsDxy.x); dec(finish.y, AnsDxy.y);
  if (OutLength <> 0) and (AnsLength <> 0) then CheckWay;

  if OutLength <> AnsLength then
    Ex(format('Incorrect way length: %d instead of %d',
      [OutLength+2, AnsLength+2]), WrongAnswer[OutLength >= AnsLength]);

  CheckClear;

  Ex('', 0);
end.
