{$APPTYPE CONSOLE}
{$MAXSTACKSIZE 16000000}

uses Math;

type TPoint = record x, y: integer; end;

const MaxNN = 100;
      MaxN = MaxNN + 2;
      dx: array[1..4] of integer = (-1, 1, 0, 0);
      dy: array[1..4] of integer = (0, 0, -1, 1);

var map: array[0..MaxN, 0..MaxN] of char;
    a: array[0..MaxN, 0..MaxN] of integer;
    queue: array[1..MaxN*MaxN] of TPoint;
    start, finish, prev: TPoint;
    i, j, l, r, x, y, t: integer;
    lx, ly, rx, ry: integer;
    fi, fo: text;

function GetTPoint(x, y: integer): TPoint;
begin
  Result.x := x; Result.y := y;
end;

procedure swap(var a, b: integer);
var t: integer;
begin
  t := a; a := b; b := t;
end;

procedure check(var a, aa: integer);
begin
  if(a > aa) then swap(a, aa);
end;

procedure GetRect;
var i, j, x, y, xx, yy: integer;
begin
  read(fi, x, y, xx, yy);
  inc(x); inc(xx); inc(y); inc(yy);
  check(x, xx); check(y, yy);
  for i := y to yy do
    for j := x to xx do
      map[i, j] := '#';

end;

function GetPoint: TPoint;
var x, y: integer;
begin
  read(fi, x, y); inc(x); inc(y);
  map[y, x] := '*';
  Result := GetTPoint(x, y);
end;

procedure QueueAdd(a: TPoint);
begin
  queue[r] := a;
  inc(r);
end;

procedure CheckAndAddChildren(var x, y: integer);
var t: integer;
begin
  for t := 1 to 4 do
    begin
     if (a[y+dy[t], x+dx[t]] = -1) and (map[y+dy[t], x+dx[t]] <> '#') then
       begin
         QueueAdd(GetTPoint(x+dx[t], y+dy[t]));
         a[y+dy[t], x+dx[t]] := a[y, x] + 1;
       end;
    end;
end;

procedure bfs;
begin
  l := 1; r := 1;
  CheckAndAddChildren(start.x, start.y);
  repeat
    x := queue[l].x; y := queue[l].y;
    CheckAndAddChildren(x, y);
    inc(l);
  until (map[y, x] = '*');
end;

procedure PrintWay(next, curr, prev: TPoint);
var t: integer;
begin
  if ((next.x - curr.x = 0) and (curr.x - prev.x <> 0) and
    (next.y - curr.y <> 0) and (curr.y - prev.y = 0)
    or
    (next.x - curr.x <> 0) and (curr.x - prev.x = 0) and
    (next.y - curr.y = 0) and (curr.y - prev.y <> 0)) then
      map[curr.y, curr.x] := '+';
  if (next.x - curr.x = 0) and (curr.x - prev.x = 0) and
    (next.y - curr.y <> 0) and (curr.y - prev.y <> 0) then
      map[curr.y, curr.x] := '|';
  if (next.x - curr.x <> 0) and (curr.x - prev.x <> 0) and
    (next.y - curr.y = 0) and (curr.y - prev.y = 0) then
      map[curr.y, curr.x] := '-';
  for t := 1 to 4 do
    if a[next.y+dy[t], next.x+dx[t]] = a[next.y, next.x] - 1 then
      begin
        PrintWay(GetTPoint(next.x+dx[t], next.y+dy[t]), next, curr);
        break;
      end;
end;

procedure ModifyAns;
begin
  lx := MaxInt; ly := MaxInt; rx := -1; ry := -1;
  for i := 1 to MaxN do
    begin
      for j := 1 to MaxN do
        begin
          if map[i, j] <> '.' then
            begin
              lx := min(lx, j); ly := min(ly, i);
              rx := max(rx, j); ry := max(ry, i);
            end;
        end;
    end;
end;

procedure WriteAns;
var i, j: integer;
begin
  for i := ry downto ly do
    begin
      for j := lx to rx do
        write(fo, map[i, j]);
      writeln(fo);
    end;
end;

begin
  AssignFile(fi, 'input.txt');
  AssignFile(fo, 'output.txt');
  reset(fi);
  rewrite(fo);
  FillChar(map, SizeOf(map), '#');
  FillChar(a, SizeOf(a), 255);
  for i := 1 to MaxN do
    for j := 1 to MaxN do
      map[i, j] := '.';
  GetRect; GetRect;
  start := GetPoint; finish := GetPoint;
  map[start.y, start.x] := '&'; a[start.y, start.x] := 0;
  map[start.y, start.x] := '*';
  bfs;
  for t := 1 to 4 do
    if a[finish.y+dy[t], finish.x+dx[t]] = a[finish.y, finish.x] - 1 then
      prev := GetTPoint(finish.x+dx[t], finish.y+dy[t]);
  for t := 1 to 4 do
    if a[prev.y+dy[t], prev.x+dx[t]] = a[prev.y, prev.x] - 1 then
      begin
        PrintWay(GetTPoint(prev.x+dx[t], prev.y+dy[t]), prev, finish);
        break;
      end;
  map[start.y, start.x] := '*'; map[finish.y, finish.x] := '*';
  ModifyAns;
  WriteAns;
  CloseFile(fi);
  CloseFile(fo);
end.
